package se.chalmers.tdv.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import org.junit.Test;

import se.chalmers.tdv.Queue;

public class QueueTest {

	@Test
	public final void testQueueZero() {
		Queue q = new Queue(4);
		assertEquals(4, q.max());
	}

	@Test
	public final void testSize() {
		Queue q = new Queue(3);
		assertEquals(0, q.size());
		q.enqueue(10);
		assertEquals(1, q.size());
	}

        @Test
	public final void testEnqueue() {
		Queue q = new Queue(1);
		Object o = new Object();
		Object o2 = new Object();
		q.enqueue(o);
		assertEquals(q.dequeue(),o);
		
		q.enqueue(o);
		q.enqueue(o2);	
		assertEquals(q.dequeue(),o);	
	}

	@Test
	public final void testDequeueEmpty() {
		Queue q = new Queue(0);
		assertNull(q.dequeue());
	}

	@Test
	public final void testDequeueNonEmpty() {
		Queue q = new Queue(2);
		Object o = new Object();
		q.enqueue(o);
		assertEquals(o, q.dequeue());
	}

	@Test
	public final void testDequeueNonEmptyLoop() {
		Queue q = new Queue(2);
		Object o1 = new Object();
		Object o2 = new Object();
		Object o3 = new Object();
		q.enqueue(o1);
		q.enqueue(o2);
		assertEquals(o1, q.dequeue());
		q.enqueue(o3);
		assertEquals(o2, q.dequeue());
		assertEquals(o3, q.dequeue());
	}
}
